'=================================================
'                MAX7456
'           Lao (klazarev@gmail.com) 2014
'=================================================
'=                                 =
'=           MAX7456 Video overlay Demo          =
'=            By EvertDekker.com 2009            =
'=================================================
$regfile = "m328pdef.DAT"
$crystal = 16000000
$hwstack = 150
$swstack = 150
$framesize = 100

Config Spi = Hard , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 16 , Noss = 0 'Setup the hardware spi
Spiinit

Config Pind.5 = Input
Plus Alias Pind.5

Config Pinb.1 = Output
Led Alias Pinb.1                                                                          ' SPI

'=== Dimension ===
Dim Temp As Byte , Lus As Byte
Dim Regaddr As Byte
Dim Regdata As Byte
Dim Buffer(2) As Byte
Dim X As Byte , Y As Byte , Char As Byte
Dim Blnk As Byte , Inv As Byte
Dim Vosreg As Byte , Hosreg As Byte
Dim Tempbyte As Byte
Dim Temptext As String * 16

Declare Sub Initmax7456()
Declare Sub Videotext(byval Text As String , Byval Ypos As Byte , Byval Xpos As Byte , Byval Blnk As Byte , Byval Inv As Byte)
Declare Sub Videochar(byval Char As Byte , Byval Ypos As Byte , Byval Xpos As Byte , Byval Blnk As Byte , Byval Inv As Byte)
Declare Sub Writereg(byval Regaddr As Byte , Byval Regdata As Byte)
Declare Sub Writecustomcharacter(byval Characters As Byte)

'=== Const ===
Const Vm0 = &H00
Const Vm1 = &H01
Const Hos = &H02
Const Vos = &H03
Const Dmm = &H04
Const Dmah = &H05
Const Dmal = &H06
Const Dmdi = &H07
Const Cmm = &H08
Const Cmah = &H09
Const Cmal = &H0A
Const Cmdi = &H0B

Reset Led

Initmax7456
Waitms 100
Hosreg = 32
Vosreg = 16

Char = 0
For Y = 0 To 15
    For X = 8 To 23
        Videochar Char , Y , X , 0 , 0
        Char = Char + 1
    Next X
Next Y

'Call Writecustomcharacter(255)

Do

Debounce Pind.5 , 0 , Writefonts , Sub                                                    'Press +
Debounce Pind.4 , 0 , Calibration                                                         'Press -

Loop
End

Writefonts:
Call Writecustomcharacter(255)
Initmax7456
Waitms 500

Videochar &H9D , 0 , 0 , 1 , 0
Videochar &H9E , 0 , 29 , 1 , 0
Videochar &H9C , 15 , 0 , 1 , 0
Videochar &H9F , 15 , 29 , 1 , 0

Char = 0
For Y = 0 To 15
    For X = 8 To 23
        Videochar Char , Y , X , 0 , 0
        Char = Char + 1
    Next X
Next Y

Return

Calibration:
Initmax7456
Waitms 100

' ===     ===
'Videochar &H9D , 0 , 0 , 0 , 0
'Videochar &H9E , 0 , 29 , 0 , 0
'Videochar &H9C , 15 , 0 , 0 , 0
'Videochar &H9F , 15 , 29 , 0 , 0

For Tempbyte = 1 To 14
Videochar &H98 , Tempbyte , 0 , 0 , 0
Videochar &H99 , Tempbyte , 29 , 0 , 0
Next Tempbyte

For Tempbyte = 1 To 28
Videochar &H9A , 0 , Tempbyte , 0 , 0
Videochar &H9B , 15 , Tempbyte , 0 , 0
Videochar &HAA , 3 , Tempbyte , 0 , 0

Next Tempbyte

Videochar &HA9 , 3 , 0 , 0 , 0
Videochar &HAB , 3 , 29 , 0 , 0

'=== 
Videochar &H41 , 1 , 12 , 0 , 0
Videochar &H42 , 1 , 13 , 0 , 0
Videochar &H43 , 1 , 14 , 0 , 0
Videochar &H44 , 1 , 15 , 0 , 0
Videochar &H45 , 1 , 16 , 0 , 0
Videochar &H46 , 2 , 12 , 0 , 0
Videochar &H47 , 2 , 13 , 0 , 0
Videochar &H48 , 2 , 14 , 0 , 0
Videochar &H49 , 2 , 15 , 0 , 0
Videochar &H4A , 2 , 16 , 0 , 0
Videochar &H4B , 3 , 12 , 0 , 0
Videochar &H4C , 3 , 13 , 0 , 0
Videochar &H4D , 3 , 14 , 0 , 0
Videochar &H4E , 3 , 15 , 0 , 0
Videochar &H4F , 3 , 16 , 0 , 0
Videochar &H50 , 4 , 12 , 0 , 0
Videochar &H51 , 4 , 13 , 0 , 0
Videochar &H52 , 4 , 14 , 0 , 0
Videochar &H53 , 4 , 15 , 0 , 0
Videochar &H54 , 4 , 16 , 0 , 0

'Videochar &H2F , 3 , 17 , 0 , 0


Hor:
Temptext = Str(hosreg)
Temptext = Format(temptext , "00")
Temptext = "%& " + Temptext
Videotext Temptext , 8 , 11 , 0 , 0
Temptext = Str(vosreg)
Temptext = Format(temptext , "00")
Temptext = "$%& " + Temptext
Videotext Temptext , 9 , 11 , 0 , 0
Videochar &H9D , 0 , 0 , 1 , 0
Videochar &H9E , 0 , 29 , 1 , 0
Videochar &H9C , 15 , 0 , 1 , 0
Videochar &H9F , 15 , 29 , 1 , 0
Videochar &H98 , 1 , 0 , 1 , 0
Videochar &H99 , 1 , 29 , 1 , 0
Videochar &H98 , 2 , 0 , 1 , 0
Videochar &H99 , 2 , 29 , 1 , 0
Videochar &H98 , 13 , 0 , 1 , 0
Videochar &H99 , 13 , 29 , 1 , 0
Videochar &H98 , 14 , 0 , 1 , 0
Videochar &H99 , 14 , 29 , 1 , 0

Do
 Debounce Pind.5 , 0 , Toright                                                            'Press +
 Debounce Pind.4 , 0 , Toleft                                                             'Press -
 Debounce Pind.3 , 0 , Writehor                                                           'press Set

Loop

Toright:
Hosreg = Hosreg + 1
If Hosreg > 63 Then Hosreg = 63
Writereg Hos , Hosreg
Goto Hor
'Return

Toleft:
Hosreg = Hosreg - 1
If Hosreg = 255 Then Hosreg = 0
Writereg Hos , Hosreg
Goto Hor
'Return

Writehor:
'Ehosreg = Hosreg
Videochar &H98 , 1 , 0 , 0 , 0
Videochar &H99 , 1 , 29 , 0 , 0
Videochar &H98 , 2 , 0 , 0 , 0
Videochar &H99 , 2 , 29 , 0 , 0
Videochar &H98 , 13 , 0 , 0 , 0
Videochar &H99 , 13 , 29 , 0 , 0
Videochar &H98 , 14 , 0 , 0 , 0
Videochar &H99 , 14 , 29 , 0 , 0
Videochar &H9A , 0 , 1 , 1 , 0
Videochar &H9B , 15 , 1 , 1 , 0
Videochar &H9A , 0 , 2 , 1 , 0
Videochar &H9B , 15 , 2 , 1 , 0
Videochar &H9A , 0 , 3 , 1 , 0
Videochar &H9B , 15 , 3 , 1 , 0
Videochar &H9A , 0 , 28 , 1 , 0
Videochar &H9B , 15 , 28 , 1 , 0
Videochar &H9A , 0 , 27 , 1 , 0
Videochar &H9B , 15 , 27 , 1 , 0
Videochar &H9A , 0 , 26 , 1 , 0
Videochar &H9B , 15 , 26 , 1 , 0
Goto Vert
'Return


Vert:
Temptext = Str(hosreg)
Temptext = Format(temptext , "00")
Temptext = "%& " + Temptext
Videotext Temptext , 8 , 11 , 0 , 0
Temptext = Str(vosreg)
Temptext = Format(temptext , "00")
Temptext = "$%& " + Temptext
Videotext Temptext , 9 , 11 , 0 , 0
Do
 Debounce Pind.5 , 0 , Toup
 Debounce Pind.4 , 0 , Todown
 Debounce Pind.3 , 0 , Writevert
Loop

Toup:
Vosreg = Vosreg - 1
If Vosreg = 255 Then Vosreg = 0
Writereg Vos , Vosreg
Goto Vert
'Return

Todown:
Vosreg = Vosreg + 1
If Vosreg > 31 Then Vosreg = 31
Writereg Vos , Vosreg
Goto Vert
'Return

Writevert:
'Evosreg = Vosreg
Videochar &H9D , 0 , 0 , 0 , 0
Videochar &H9E , 0 , 29 , 0 , 0
Videochar &H9C , 15 , 0 , 0 , 0
Videochar &H9F , 15 , 29 , 0 , 0
Videochar &H9A , 0 , 1 , 0 , 0
Videochar &H9B , 15 , 1 , 0 , 0
Videochar &H9A , 0 , 2 , 0 , 0
Videochar &H9B , 15 , 2 , 0 , 0
Videochar &H9A , 0 , 3 , 0 , 0
Videochar &H9B , 15 , 3 , 0 , 0
Videochar &H9A , 0 , 28 , 0 , 0
Videochar &H9B , 15 , 28 , 0 , 0
Videochar &H9A , 0 , 27 , 0 , 0
Videochar &H9B , 15 , 27 , 0 , 0
Videochar &H9A , 0 , 26 , 0 , 0
Videochar &H9B , 15 , 26 , 0 , 0
Goto Hor
'Return



Sub Initmax7456()

 Writereg Vm0 , &B00000010
 Waitms 1000
 Writereg Vm0 , &B01111100
 Writereg Vm1 , &B00001111
 Writereg Dmm , &B01000000
 Writereg Hos , Hosreg
 Writereg Vos , Vosreg

End Sub


Sub Videotext(byval Text As String , Byval Ypos As Byte , Byval Xpos As Byte , Blnk As Byte , Inv As Byte)
 Local Charcount As Byte , Tempstring As String * 1 , Tempbyte As Byte , Position As Word , Chars As Byte , Attribute As Byte
 Attribute = 0
 Charcount = Len(text) - 1
 For Chars = 0 To Charcount
  Position = Ypos * 30
  Position = Position + Xpos
  Position = Position + Chars
  If Blnk = 1 Then
    Set Attribute.6
  Else
    Reset Attribute.6
  End If
  If Inv = 1 Then
    Set Attribute.5
  Else
    Reset Attribute.5
  End If
  Regdata = High(position)
  Writereg Dmah , Regdata
  Regdata = Low(position)
  Writereg Dmal , Regdata
  Tempbyte = Chars + 1
  Tempstring = Mid(text , Tempbyte , 1)
  Tempbyte = Asc(tempstring)
  Writereg Dmdi , Tempbyte
  Regdata = High(position)
  Regdata = Regdata Or &B00000010
  Writereg Dmah , Regdata
  Regdata = Low(position)
  Writereg Dmal , Regdata
  Writereg Dmdi , Attribute
 Next Charcount                                                                           '
End Sub

Sub Videochar(byval Char As Byte , Byval Ypos As Byte , Byval Xpos As Byte , Byval Blnk As Byte , Byval Inv As Byte)
Local Tempbyte As Byte , Position As Word , Attribute As Byte
 Attribute = 0
 Position = Ypos * 30
 Position = Position + Xpos
 If Blnk = 1 Then
    Set Attribute.6
 Else
    Reset Attribute.6
 End If
 If Inv = 1 Then
    Set Attribute.5
  Else
    Reset Attribute.5
 End If
 Regdata = High(position)
 Writereg Dmah , Regdata
 Regdata = Low(position)
 Writereg Dmal , Regdata
 Tempbyte = Char
 Writereg Dmdi , Tempbyte
 Regdata = High(position)
 Regdata = Regdata Or &B00000010
 Writereg Dmah , Regdata
 Regdata = Low(position)
 Writereg Dmal , Regdata
 Writereg Dmdi , Attribute
End Sub

Sub Writecustomcharacter(byval Characters As Byte)
 Local Count As Byte
   Restore Customcharacter
 For Count = 0 To Characters
  Writereg Vm0 , &B01110100
  Read Regdata
  Writereg Cmah , Regdata
  Set Led
  For Lus = 0 To 53
       Writereg Cmal , Lus
       Read Regdata
       Writereg Cmdi , Regdata
  Next Lus
  Writereg Cmm , &HA0
  Waitms 200
  Reset Led
 Next Count
  Writereg Vm0 , &B01111100
End Sub

Sub Writereg(byval Regaddr As Byte , Byval Regdata As Byte)
 Buffer(1) = Regaddr
 Buffer(2) = Regdata
Spiout Buffer(1) , 2
End Sub

End

$include "meteo_ukr_black.bas"
